

from CompuCell import MitosisSimplePlugin      
from PyPlugins import *
from PySteppables import CellList
from CompuCell import NeighborFinderParams
import time,sys

class MitosisPyPluginBase(StepperPy,Field3DChangeWatcherPy):
   def __init__(self,_simulator,_changeWatcherRegistry,_stepperRegistry):

   
      Field3DChangeWatcherPy.__init__(self,_changeWatcherRegistry)
      self.simulator=_simulator
      self.mitosisPlugin=MitosisSimplePlugin()
      self.mitosisPlugin.setPotts(self.simulator.getPotts())
      self.mitosisPlugin.turnOn()
      self.mitosisPlugin.init(self.changeWatcher.sim)
      self.counter=0
      self.mitosisFlag=0
      self.doublingVolumeDict=0
      _changeWatcherRegistry.registerPyChangeWatcher(self)
      _stepperRegistry.registerPyStepper(self)        
   
      
      
      
   def setPotts(self,potts):
      self.mitosisPlugin.setPotts(potts)
   
   def setDoublingVolume(self,_doublingVolume):
      self.doublingVolume=_doublingVolume;
      self.mitosisPlugin.setDoublingVolume(self.doublingVolume)
   
   def setCellDoublingVolume(self,_doublingVolumeDict):
      self.doublingVolumeDict=_doublingVolumeDict;
      for i in self.doublingVolumeDict.keys():
         print self.doublingVolumeDict[i]
         
   def field3DChange(self):
      cell = self.changeWatcher.newCell
      if cell and self.doublingVolumeDict.has_key(cell.type) and cell.volume>self.doublingVolumeDict[cell.type]:
         print "Type: ", cell.type, " Doubling Volume: ", self.doublingVolumeDict[cell.type], " Current Volume: ", cell.volume
         self.setDoublingVolume(self.doublingVolumeDict[cell.type])
         self.mitosisPlugin.field3DChange(self.changeWatcher.changePoint,self.changeWatcher.newCell,self.changeWatcher.newCell)
         self.mitosisFlag=1
         
   def step(self):
      if self.mitosisFlag:
         print "ABOUT TO DO MITOSIS"
         self.mitosisFlag=self.mitosisPlugin.doMitosis()
         self.childCell=self.mitosisPlugin.getChildCell()
         self.parentCell=self.mitosisPlugin.getParentCell()
         self.updateAttributes()
         self.mitosisFlag=0
         
   def updateAttributes(self):
      self.childCell.targetVolume=self.parentCell.targetVolume
      self.childCell.lambdaVolume=self.parentCell.lambdaVolume
      self.childCell.type=self.parentCell.type


class MitosisPyPlugin(MitosisPyPluginBase):
   def __init__(self , _simulator , _changeWatcherRegistry , _stepperRegistry):
      MitosisPyPluginBase.__init__(self,_simulator,_changeWatcherRegistry,_stepperRegistry)


   def updateAttributes(self):
      
      
      if self.parentCell.type==6 or self.parentCell.type==5:
         self.childCell.type=6
	 self.childCell.targetVolume=35
         self.childCell.lambdaVolume=12
         self.parentCell.targetVolume=35
         self.parentCell.lambdaVolume=12
	 self.childCell.targetSurface=70
         self.childCell.lambdaSurface=10
         self.parentCell.targetSurface=70
         self.childCell.lambdaSurface=10

     
      if self.parentCell.type==4 :
         self.childCell.type=4
	 self.childCell.targetVolume=30
         self.childCell.lambdaVolume=15
         self.parentCell.targetVolume=30
         self.parentCell.lambdaVolume=15
	 
	 

