


from PySteppables import *
import CompuCell
import sys
import time
from math import *
from XMLUtils import dictionaryToMapStrStr as d2mss
from XMLUtils import CC3DXMLListPy

class VolumeParamSteppable(SteppablePy):
   def __init__(self,_simulator,_frequency=1):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)
      self.nTrackerPlugin=CompuCell.getNeighborTrackerPlugin()
      self.cellFieldG=self.simulator.getPotts().getCellFieldG()
      self.focalPointPlasticityPlugin=CompuCell.getFocalPointPlasticityPlugin()
      self.dim=self.cellFieldG.getDim()
      self.fieldNameNeoVascular = 'VEGF2'
      self.fieldNameRPE = 'Oxygen'
      self.fieldNameBM = 'MMP'
      self.output_file = open("902-JRB-28JRR-40JRP-16LRB60LRR300.txt",'w')

      
   def start(self):
      import CompuCellSetup
      for cell in self.cellList:


         if cell.type== 1 or cell.type== 2:
	    cell.targetVolume=67.0
            cell.lambdaVolume=25.0
	    cell.targetSurface=120.0
            cell.lambdaSurface=25.0
	    list_attrib=CompuCell.getPyAttrib(cell)
	    list_attrib[0:2]=[0,801]
	 if cell.type== 7:
	    cell.targetVolume=42.0
            cell.lambdaVolume=12.0
	    cell.targetSurface=70.0
            cell.lambdaSurface=10.0
	 if cell.type== 5:
	    cell.targetVolume=35.0
            cell.lambdaVolume=12.0
	    cell.targetSurface=70.0
            cell.lambdaSurface=10.0
	 if cell.type==3:
	    cell.targetVolume=1
            cell.lambdaVolume=1000000000000.0
	    cell.targetSurface=6
            cell.lambdaSurface=1000000000.0
	 if cell.type==4:
	    cell.targetVolume=36
            cell.lambdaVolume=10.0
	    #cell.targetSurface=6
            #cell.lambdaSurface=1000000000.0
  	 if cell.type==8:
	    cell.targetVolume=1000
            cell.lambdaVolume=25.0
	    cell.targetSurface=900.0
            cell.lambdaSurface=25.0
	 if cell.type==9:
	    cell.targetVolume=512
            cell.lambdaVolume=12.0
	    cell.targetSurface=600.0
            cell.lambdaSurface=10.0
	 if cell.type == 5:
	    list_attrib=CompuCell.getPyAttrib(cell)
	    list_attrib[0:1]=[0]
	 
   def step(self,mcs):
      fieldNeoVasc=CompuCell.getConcentrationField(self.simulator,self.fieldNameNeoVascular)
      fieldOXY=CompuCell.getConcentrationField(self.simulator,self.fieldNameRPE)
      fieldMMP=CompuCell.getConcentrationField(self.simulator,self.fieldNameBM)
      self.Potts=self.simulator.getPotts()
      StalkTotalVolume=1.0
      POS_BRM_contact_total=0
      POS_CNV_contact_total=0
      CNV_BRM_contact_total=0
      totalVEGF2=0
      StalkTotal=0.01
      RPETotal=0
      HRPETotal=0
      pressure = 0
      RPE_BRM_totalArea = 0
      
	      
      
      for cell in self.cellList:
         #print "lambda Volume: ", cell.lambdaVolume , "  TargetVolume: " , cell.targetVolume,
	 list_attrib=CompuCell.getPyAttrib(cell)
	 POS_BRM_contact=0
	 POS_CNV_contact=0
	 CNV_BRM_contact=0
	 Stalk_NEI=0
             
            
         ### Vascular
         if cell.type == 7:
            totalArea = 0
	    Tip_Neighbor=0
	    
            cellNeighborList=CellNeighborListAuto(self.nTrackerPlugin,cell)
            for neighborSurfaceData in cellNeighborList:
               #Check to ensure cell neighbor is not medium	       
               if neighborSurfaceData.neighborAddress:


                  if neighborSurfaceData.neighborAddress.type == 5 or neighborSurfaceData.neighborAddress.type == 6 or neighborSurfaceData.neighborAddress.type == 7:
                        
                     #sum up common surface area of cell with its neighbors
                     totalArea+=neighborSurfaceData.commonSurfaceArea 
                     #print "concentration: ", concentration,"  commonSurfaceArea:",neighborSurfaceData.commonSurfaceArea



	    pt=CompuCell.Point3D()
            pt.x=int(floor(cell.xCM/max(float(cell.volume),0.001)))
            pt.y=int(floor(cell.yCM/max(float(cell.volume),0.001)))
            pt.z=int(floor(cell.zCM/max(float(cell.volume),0.001)))
            concentration=fieldNeoVasc.get(pt)
            if concentration < 0.00001 and mcs>1000:
	       cell.targetVolume=0.0
	       cell.targetSurface=0.0
	 # Stalk
	 if cell.type == 6:

            totalArea = 0
	    StalkTotalVolume+=cell.volume
	    StalkTotal+=1
	    pt=CompuCell.Point3D()
	    pt.x=int(floor(cell.xCM/max(float(cell.volume),0.001)))
            pt.y=int(floor(cell.yCM/max(float(cell.volume),0.001)))
            pt.z=int(floor(cell.zCM/max(float(cell.volume),0.001)))
            concentration=fieldNeoVasc.get(pt)
            cellNeighborList=CellNeighborListAuto(self.nTrackerPlugin,cell)
            for neighborSurfaceData in cellNeighborList:
               #Check to ensure cell neighbor is not medium
               if neighborSurfaceData.neighborAddress:
                  if neighborSurfaceData.neighborAddress.type == 5 or neighborSurfaceData.neighborAddress.type == 6 or neighborSurfaceData.neighborAddress.type == 7:
                        
                     #sum up common surface area of cell with its endothelial neighbors
                     totalArea+=neighborSurfaceData.commonSurfaceArea 
                  if neighborSurfaceData.neighborAddress.type == 3:
                      #sum up common surface area of cell with Bruch's membrane
		     CNV_BRM_contact+=neighborSurfaceData.commonSurfaceArea
	    CNV_BRM_contact_total+= CNV_BRM_contact
            if totalArea < 17 and (cell.targetVolume-cell.volume)<=2: # a stalk cell grow when its contact area and internal pressure is less than the two corresponding thresholds 

               #Growth rate equation

	       cell.targetVolume+=0.426 *  concentration/(0.005 + concentration)
	       cell.targetSurface+= 0.852 *  concentration/(0.005 + concentration)
	       # elongate the equilibrium lengths of plastic links with other ECs when stalk cells grow
               plasticityList=FocalPointPlasticityDataList(self.focalPointPlasticityPlugin,cell)
               for plasticityData in plasticityList:
		  if plasticityData.neighborAddress.type==7 or plasticityData.neighborAddress.type==6:
		    ave_targetDistance= (cell.volume + plasticityData.neighborAddress.volume)/15.0
		    vol = plasticityData.neighborAddress.volume
		    xmid=float(plasticityData.neighborAddress.xCM) / (vol+0.001) 
		    ymid=float(plasticityData.neighborAddress.yCM) / (vol+0.001) 
		    zmid=float(plasticityData.neighborAddress.zCM) / (vol+0.001)
		    xdiff = xmid-pt.x
		    ydiff = ymid-pt.y
		    zdiff = zmid-pt.z
		    if abs(xdiff) > (self.dim.x/2):
		      xdiff=(abs(xdiff)-self.dim.x)
		    if abs(ydiff) > (self.dim.y/2):
		      ydiff=(abs(ydiff)-self.dim.y)

		    actualDist = ((xdiff*xdiff)+(ydiff*ydiff)+(zdiff*zdiff))**(0.5)
		    
		    print "plasticityData.neighborAddress.type  ", plasticityData.neighborAddress.type,"plasticityData.targetDistance",plasticityData.targetDistance, "actual dist ", actualDist
                    self.focalPointPlasticityPlugin.setFocalPointPlasticityParameters(cell,plasticityData.neighborAddress,plasticityData.lambdaDistance,actualDist,actualDist*2)
            if (concentration < 0.00001 and mcs>1000): # kill stalk cells when RPE-derived VEGF is too low, initial concentration of is 0 so we wait 1000mcs for the RPE-derived VEGF to reach its stationary concentration
	       cell.targetVolume=0.0
	       cell.targetSurface=0.0

         
	  #### Tip
         if cell.type == 5 and mcs==400: #tip cells are capable of MMP secretion for the first 24 hours
	    cell.type = 6
	                 
     
	    
         ###RPE Cells
         if cell.type == 1 or cell.type == 2:
            totalArea=0
	    RPETotal+=1
            pt=CompuCell.Point3D()
            pt.x=int(floor(cell.xCM/max(float(cell.volume),0.001)))
            pt.y=int(floor(cell.yCM/max(float(cell.volume),0.001)))
            pt.z=int(floor(cell.zCM/max(float(cell.volume),0.001)))
            if pt.x==40:
	      pt.x=0
	    if pt.y==40:
	      pt.y=0
	    concentration2=fieldOXY.get(pt)
	    cellNeighborList=CellNeighborListAuto(self.nTrackerPlugin,cell)
            for neighborSurfaceData in cellNeighborList:
               #Check to ensure cell neighbor is not medium
               if neighborSurfaceData.neighborAddress:
                  if neighborSurfaceData.neighborAddress.type == 3:
		     RPE_BRM_totalArea+=neighborSurfaceData.commonSurfaceArea
                  if neighborSurfaceData.neighborAddress.type == 3 or neighborSurfaceData.neighborAddress.type == 1 or neighborSurfaceData.neighborAddress.type == 2:      
                     #sum up common surface area of cell with its neighbors
                     totalArea+=neighborSurfaceData.commonSurfaceArea

            
	    if ( totalArea == 0  and mcs>10): # RPE cells die when lose contact with their other RPEs and Bruch's membrane
	       cell.targetVolume-=0.5
               cell.targetSurface-=0.5
	       if cell.targetVolume<0 or cell.targetSurface<0:  
		cell.targetVolume=0.0
		cell.targetSurface=0.0
		  
	       
	    if cell.type==1 and concentration2 < 49 and list_attrib[1] > 800: #switch to HRPE cell type when PO2 is less than 49mmHg 

	       cell.type=2
	       HRPETotal+=1
	       RPETotal-=1
	       list_attrib[0] = 1
	    if cell.type==1:
	       list_attrib[1] += 1

	    if cell.type==2 and (concentration2 > 49 or list_attrib[0] > 800): #hypoxic RPE cells stop VEGF overexpression after 48 hours
               #aveox = aveox+concentration2;
	       #print "concentration2", concentration2
	       cell.type=1
	       list_attrib[0] = 0
	       list_attrib[1] = 1
	    if cell.type==2 and (concentration2 < 49 or list_attrib[0] < 800):
	       list_attrib[0] += 1
	       #print "HRPE  ", list_attrib[0]
	       HRPETotal+=1
	       RPETotal-=1 
        


         ##BM Cells
         if cell.type == 3 and mcs<500:
            pt=CompuCell.Point3D()

            pt.x=int(floor(cell.xCM/max(float(cell.volume),0.000000001)))
            pt.y=int(floor(cell.yCM/max(float(cell.volume),0.000000001)))
            pt.z=int(floor(cell.zCM/max(float(cell.volume),0.000000001)))
	    concentration2=fieldMMP.get(pt)
            cell.targetVolume-=0.075*concentration2 # reducing Bruch's membrane target volume proportional to MMP concentration and removing the voxel when target volume becomes zero

	 if cell.type == 8 or cell.type == 9: # calculating total common contact area between POS and Bruch's membrane and POS and CNV
            
            cellNeighborList=CellNeighborListAuto(self.nTrackerPlugin,cell)
	    for neighborSurfaceData in cellNeighborList:
               #Check to ensure cell neighbor is not medium
               if neighborSurfaceData.neighborAddress:
                  if neighborSurfaceData.neighborAddress.type == 3:
		     POS_BRM_contact+=neighborSurfaceData.commonSurfaceArea
                  if neighborSurfaceData.neighborAddress.type == 5 or neighborSurfaceData.neighborAddress.type == 6:
		     POS_CNV_contact+=neighborSurfaceData.commonSurfaceArea
	    POS_BRM_contact_total+= POS_BRM_contact
	    POS_CNV_contact_total+= POS_CNV_contact
               

      if int(mcs/100.0)==mcs/100.0: #writing cell counts and contact areas to a file every 100mcs
        
	 self.output_file = open("902-JRB-28JRR-40JRP-16LRB60LRR300.txt",'a')
	 self.output_file.write("%d %d %d %d %d %d %d" %( StalkTotal, RPETotal, HRPETotal , POS_BRM_contact_total,POS_CNV_contact_total,CNV_BRM_contact_total,RPE_BRM_totalArea))
	 self.output_file.write("\n")
	 self.output_file.close()




